/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin/proc.h>
#include <bin/types.h>
#include <fs/fs.h>
#include <stddef.h>
#include <stdlib.h>

int bin_proc_fd_alloc(struct bin_proc *const p, const struct fs_fd *const fs_fd,
    const int flags)
{
    int fd = 0;

    for (size_t i = 0; i < p->n_fds;)
        if (fd == p->fds[i].fd)
        {
            fd++;
            i = 0;
        }
        else
            i++;

    const size_t n = p->n_fds + 1;
    struct bin_proc_fd *const fds = realloc(p->fds, n * sizeof *fds);

    if (!fds)
        return -1;

    fds[p->n_fds++] = (const struct bin_proc_fd)
    {
        .fd = fd,
        .flags = flags,
        .fs_fd = *fs_fd
    };

    p->fds = fds;
    return fd;
}
